# LDAP Account Manager

# lib/modules.inc

# Properties

author
author
author
package

## Description

Interface between modules and other parts of LAM.

## Functions

### getModuleAlias( string $name, string $scope, ) : string

#### Description

Returns the alias name of a module

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$name | string | the module name |
$scope | string | the account type ("user", "group", "host") |

#### Return value

Type | Description
--- | ---
string | alias name

### is_base_module( string $name, string $scope, ) : boolean

#### Description

Returns true if the module is a base module

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$name | string | the module name |
$scope | string | the account type ("user", "group", "host") |

#### Return value

Type | Description
--- | ---
boolean | true if base module

### get_ldap_filter( string $scope, ) : string

#### Description

Returns the LDAP filter used by the account lists

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$scope | string | the account type ("user", "group", "host") |

#### Return value

Type | Description
--- | ---
string | LDAP filter

### getRDNAttributes( string $scope, array $selectedModules = null, ) : array

#### Description

Returns a list of LDAP attributes which can be used to form the RDN.
The list is already sorted by the priority given by the nodules.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$scope | string | account type (user, group, host) |
$selectedModules | array | return only RDN attributes of these modules | null

#### Return value

Type | Description
--- | ---
array | list of LDAP attributes

### getModulesDependencies( string $scope, ) : array

#### Description

Returns a hash array (module name => dependencies) of all module dependencies
"dependencies" contains an array with two sub arrays: depends, conflicts
The elements of "depends" are either module names or an array of module names (OR-case).
The elements of conflicts are module names.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$scope | string | the account type (user, group, host) |

#### Return value

Type | Description
--- | ---
array | dependencies

### check_module_depends( array $selected, array $deps, ) : mixed

#### Description

Checks if there are missing dependencies between modules.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$selected | array | selected module names |
$deps | array | module dependencies |

#### Return value

Type | Description
--- | ---
mixed | false if no misssing dependency was found, otherwise an array of array(selected module, depending module) if missing dependencies were found

### check_module_conflicts( array $selected, array $deps, ) : boolean

#### Description

Checks if there are conflicts between modules

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$selected | array | selected module names |
$deps | array | module dependencies |

#### Return value

Type | Description
--- | ---
boolean | false if no conflict was found, otherwise an array of array(selected module, conflicting module) if conflicts were found

### getAvailableModules( string $scope, boolean $mustSupportAdminInterface = false, ) : array

#### Description

Returns an array with all available user module names

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$scope | string | account type (user, group, host) |
$mustSupportAdminInterface | boolean | module must support LAM admin interface (default: false) | false

#### Return value

Type | Description
--- | ---
array | list of possible modules

### getProfileOptions( string $scope, ) : array

#### Description

Returns the elements for the profile page.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$scope | string | account type (user, group, host) |

#### Return value

Type | Description
--- | ---
array | profile elements

### checkProfileOptions( string $scope, array $options, ) : array

#### Description

Checks if the profile options are valid

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$scope | string | account type (user, group, host) |
$options | array | hash array containing all options (name => array(...)) |

#### Return value

Type | Description
--- | ---
array | list of error messages

### getConfigOptions( array $scopes, ) : array

#### Description

Returns a hash array (module name => elements) of all module options for the configuration page.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$scopes | array | hash array (module name => array(account types)) |

#### Return value

Type | Description
--- | ---
array | configuration options

### checkConfigOptions( array $scopes, array $options, ) : array

#### Description

Checks if the configuration options are valid

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$scopes | array | hash array (module name => array(account types)) |
$options | array | hash array containing all options (name => array(...)) |

#### Return value

Type | Description
--- | ---
array | list of error messages

### getHelp( string $module, string $helpID, string $scope = '', ) : array

#### Description

Returns a help entry from an account module.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | module name |
$helpID | string | help identifier |
$scope | string | account type | ''

#### Return value

Type | Description
--- | ---
array | help entry

### getAvailablePDFFields( string $scope, ) : array

#### Description

Returns a list of available PDF entries.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$scope | string | account type (user, group, host) |

#### Return value

Type | Description
--- | ---
array | PDF entries (field ID =&gt; field label)

### getUploadColumns( string $scope, array $selectedModules, ) : array

#### Description

Returns an array containing all input columns for the file upload.
Syntax:
array(
string: name, // fixed non-translated name which is used as column name (should be of format: <module name>_<column name>)
string: description, // short descriptive name
string: help, // help ID
string: example, // example value
boolean: required // true, if user must set a value for this column
)

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$scope | string | account type |
$selectedModules | array | selected account modules |

#### Return value

Type | Description
--- | ---
array | column list

### buildUploadAccounts( string $scope, array $data, array $ids, array $selectedModules, ) : mixed

#### Description

This function builds the LDAP accounts for the file upload.
If there are problems status messages will be printed automatically.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$scope | string | account type |
$data | array | array containing one account in each element |
$ids | array | array(<column_name> => <column number>) |
$selectedModules | array | selected account modules |

#### Return value

Type | Description
--- | ---
mixed | array including accounts or false if there were errors

### doUploadPreActions( String $scope, array $selectedModules, array $attributes, ) : array

#### Description

Runs any actions that need to be done before an LDAP entry is created.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$scope | String | account type |
$selectedModules | array | list of selected account modules |
$attributes | array | LDAP attributes of this entry (attributes are provided as reference, handle modifications of $attributes with care) |

#### Return value

Type | Description
--- | ---
array | array which contains status messages. Each entry is an array containing the status message parameters.

### doUploadPostActions( string $scope, array $data, array $ids, array $failed, array $selectedModules, array $accounts, ) : array

#### Description

This function executes one post upload action.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$scope | string | account type |
$data | array | array containing one account in each element |
$ids | array | array(<column_name> => <column number>) |
$failed | array | list of accounts which were not created successfully |
$selectedModules | array | list of selected account modules |
$accounts | array | list of LDAP entries |

#### Return value

Type | Description
--- | ---
array | current status &lt;br&gt; array ( &lt;br&gt; &#039;status&#039; =&gt; &#039;finished&#039; | &#039;inProgress&#039; &lt;br&gt; &#039;module&#039; =&gt; &lt;name of active module&gt; &lt;br&gt; &#039;progress&#039; =&gt; 0..100 &lt;br&gt; &#039;errors&#039; =&gt; array (&lt;array of parameters for StatusMessage&gt;) &lt;br&gt; )

### getRequiredExtensions( ) : array

#### Description

Returns true if the module is a base module

#### Return value

Type | Description
--- | ---
array | required extensions

### parseHtml( string $module, mixed $input, array $values, boolean $restricted, integer $tabindex, string $scope, ) : array

#### Description

Takes a list of meta-HTML elements and prints the equivalent HTML output.
The modules are not allowed to display HTML code directly but return meta HTML code. This allows to have a common design for all module pages.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$module | string | Name of account module |
$input | mixed | htmlElement or array of htmlElement elements |
$values | array | List of values which override the defaults in $input (name => value) |
$restricted | boolean | If true then no buttons will be displayed |
$tabindex | integer | Start value of tabulator index for input fields |
$scope | string | Account type |

#### Return value

Type | Description
--- | ---
array | List of input field names and their type (name =&gt; type)

### lamCompareDescriptiveOptions( array $a, array $b, ) : integer

#### Description

Helper function to sort descriptive options in parseHTML().
It compares the second entries of two arrays.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$a | array | first array |
$b | array | second array |

#### Return value

Type | Description
--- | ---
integer | compare result

### printHelpLink( array $entry, String $number, String $module = '', String $scope = '', ) : n/a

#### Description

Prints a LAM help link.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$entry | array | help entry |
$number | String | help number |
$module | String | module name | ''
$scope | String | account scope | ''

#### Return value

Type | Description
--- | ---
n/a | n/a

## Classes

### accountContainer

# Properties

Extends
Implements
package
modules
Abstract
No
Final
No

#### Description

This class includes all modules and attributes of an account.

#### Methods

__construct, __sleep, __wakeup, continue_main, fixLDAPAttributes, getAccountModule, getAccountModules, getOUs, getParentDN, getRDN, get_pdfEntries, get_type, loadProfileIfRequested, load_account, new_account, printCommonControls, printModuleContent, printModuleTabs, printPageFooter, printPageHeader, printPasswordPromt, printSuccessPage, save_account, save_module_attributes, setNewPassword, showSetPasswordButton, sortModules,

### __construct( string $type, string $base, ) : n/a

#### Description

Constructor

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$type | string | account type |
$base | string | key in $_SESSION where this object is saved |

#### Return value

Type | Description
--- | ---
n/a | n/a

### __sleep( ) : array

#### Description

Encrypts sensitive data before storing in session.

#### Return value

Type | Description
--- | ---
array | list of attributes which are serialized

### __wakeup( ) : n/a

#### Description

Decrypts sensitive data after accountContainer was loaded from session.

#### Return value

Type | Description
--- | ---
n/a | n/a

### continue_main( ) : n/a

#### Description

This function is called when the user clicks on any button on the account pages.
It prints the HTML code of each account page.

#### Return value

Type | Description
--- | ---
n/a | n/a

### fixLDAPAttributes( array $attributes, array $modules, ) : array

#### Description

Fixes spelling errors in the attribute names.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$attributes | array | LDAP attributes |
$modules | array | list of active modules |

#### Return value

Type | Description
--- | ---
array | fixed attributes

### getAccountModule( string $name, ) : \baseModule

#### Description

Returns the account module with the given class name

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$name | string | class name (e.g. posixAccount) |

#### Return value

Type | Description
--- | ---
\baseModule | account module

### getAccountModules( ) : array

#### Description

Returns the included account modules.

#### Return value

Type | Description
--- | ---
array | modules

### getOUs( ) : array

#### Description

Returns a list of OUs that exist for this account type.

#### Return value

Type | Description
--- | ---
array | OU list

### getParentDN( String $dn, ) : String

#### Description

Returns the parent DN of a given DN.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$dn | String | DN |

#### Return value

Type | Description
--- | ---
String | DN

### getRDN( String $dn, ) : String

#### Description

Returns the RDN part of a given DN.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$dn | String | DN |

#### Return value

Type | Description
--- | ---
String | RDN

### get_pdfEntries( ) : \list

#### Description

Returns a list of possible PDF entries for this account.

#### Return value

Type | Description
--- | ---
\list | of PDF entries (array(&lt;name&gt; =&gt; &lt;PDF lines&gt;))

### get_type( ) : string

#### Description

Returns the accout type of this object (e.g. user, group, host).

#### Return value

Type | Description
--- | ---
string | account type

### loadProfileIfRequested( ) : boolean

#### Description

Checks if the user requested to load a profile.

#### Return value

Type | Description
--- | ---
boolean | true, if profile was loaded

### load_account( string $dn, array $infoAttributes = array(), ) : array

#### Description

Loads an LDAP account with the given DN.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$dn | string | the DN of the account |
$infoAttributes | array | list of additional informational attributes that are added to the LDAP attributes E.g. this is used to inject the clear text password in the file upload. Informational attribute names must start with "INFO.". | array()

#### Return value

Type | Description
--- | ---
array | error messages

### new_account( ) : n/a

#### Description

This function will prepare the object for a new account.

#### Return value

Type | Description
--- | ---
n/a | n/a

### printCommonControls( int $tabindex, ) : n/a

#### Description

Prints common controls like the save button and the ou selection.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$tabindex | int | tabindex for GUI elements |

#### Return value

Type | Description
--- | ---
n/a | n/a

### printModuleContent( array $result, boolean $stopProcessing, ) : n/a

#### Description

Prints the content part provided by the current module.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$result | array | list of messages |
$stopProcessing | boolean | true if page should end after displaying the messages |

#### Return value

Type | Description
--- | ---
n/a | n/a

### printModuleTabs( ) : n/a

#### Description

Prints the HTML code of the module tabs.

#### Return value

Type | Description
--- | ---
n/a | n/a

### printPageFooter( ) : n/a

#### Description

Prints the footer of the account pages.

#### Return value

Type | Description
--- | ---
n/a | n/a

### printPageHeader( ) : n/a

#### Description

Prints the header of the account pages.

#### Return value

Type | Description
--- | ---
n/a | n/a

### printPasswordPromt( ) : n/a

#### Description

Prints the input fields of the central password service.

#### Return value

Type | Description
--- | ---
n/a | n/a

### printSuccessPage( array $messages, ) : n/a

#### Description

Prints the HTML code to notify the user about the successful saving.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$messages | array | array which contains status messages. Each entry is an array containing the status message parameters. |

#### Return value

Type | Description
--- | ---
n/a | n/a

### save_account( ) : array

#### Description

This function will save an account to the LDAP database.

#### Return value

Type | Description
--- | ---
array | list of status messages

### save_module_attributes( array $attributes, array $orig, ) : array

#### Description

This function checks which LDAP attributes have changed while the account was edited.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$attributes | array | list of current LDAP attributes |
$orig | array | list of old attributes when account was loaded |

#### Return value

Type | Description
--- | ---
array | an array which can be passed to $this-&gt;saveAccount()

### setNewPassword( array $input, ) : n/a

#### Description

Sets the new password in all selected account modules.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$input | array | input parameters |

#### Return value

Type | Description
--- | ---
n/a | n/a

### showSetPasswordButton( ) : boolean

#### Description

Returns if the page should show a button to set the password.

#### Return value

Type | Description
--- | ---
boolean | show or hide button

### sortModules( ) : n/a

#### Description

Sorts the module buttons for the account page.

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Properties

$attributes, $attributes_orig, $base, $cachedOUs, $current_page, $dnSuffix, $dn_orig, $finalDN, $isNewAccount, $lastLoadedProfile, $module, $order, $rdn, $sendPasswordViaMail, $sendPasswordViaMailAlternateAddress, $subpage, $titleBarSubtitle, $titleBarTitle, $type,

### public $attributes =

Array of all used attributes Syntax is attribute => array ( objectClass => MUST or MAY, .
..)

### public $attributes_orig =

original LDAP attributes when account was loaded from LDAP

### private $base =

Name of accountContainer variable in session

### private $cachedOUs = null

cache for existing OUs

### private $current_page = 0

This variable stores the page number of the currently displayed page

### public $dnSuffix =

DN suffix of the account

### public $dn_orig =

DN of account when it was loaded

### public $finalDN =

DN of saved account

### public $isNewAccount =

True if this is a newly created account

### private $lastLoadedProfile = ''

name of last loaded account profile

### private $module =

This is an array with all module objects

### private $order =

Module order

### public $rdn =

RDN attribute of this account

### private $sendPasswordViaMail = null

send password via mail

### private $sendPasswordViaMailAlternateAddress = null

send password via mail to this alternate address

### private $subpage =

This variable is set to the pagename of a subpage if it should be displayed

### private $titleBarSubtitle = null

subtitle in title bar

### private $titleBarTitle = null

main title in title bar

### private $type =

This variale stores the account type.
Currently "user", "group" and "host" are supported.

## Interfaces

### passwordService

# Properties

Extends
Implements
package
modules
Abstract
Final

#### Description

This interface needs to be implemented by all account modules which manage passwords.
It allows LAM to provide central password changes.

#### Methods

managesPasswordAttributes, passwordChangeRequested, supportsForcePasswordChange,

### managesPasswordAttributes( ) : boolean

#### Description

This method specifies if a module manages password attributes. The module alias will then appear as option in the GUI.
If the module only wants to get notified about password changes then return false.

#### Return value

Type | Description
--- | ---
boolean | true if this module manages password attributes

### passwordChangeRequested( String $password, array $modules, boolean $forcePasswordChange, ) : array

#### Description

This function is called whenever the password should be changed. Account modules must change their password attributes only if the modules list contains their module name.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$password | String | new password |
$modules | array | list of modules for which the password should be changed |
$forcePasswordChange | boolean | force the user to change his password at next login |

#### Return value

Type | Description
--- | ---
array | list of error messages if any as parameter array for StatusMessage e.g. return arrray(array(&#039;ERROR&#039;, &#039;Password change failed.&#039;))

### supportsForcePasswordChange( ) : boolean

#### Description

Specifies if this module supports to force that a user must change his password on next login.

#### Return value

Type | Description
--- | ---
boolean | force password change supported

Documentation was generated by phpDocumentor 2.0.1 .

# Namespaces

- global

# Packages

- Crypt_AES
  - Crypt_AES
    Pure-PHP implementation of AES.
- Crypt_DES
  - Crypt_DES
    Pure-PHP implementation of DES.
- Crypt_Hash
  - Crypt_Hash
    Pure-PHP implementations of keyed-hash message authentication codes (HMACs) and various cryptographic hashing functions.
- Crypt_RC4
  - Crypt_RC4
    Pure-PHP implementation of RC4.
- Crypt_RSA
  - Crypt_RSA
    Pure-PHP PKCS#1 compliant implementation of RSA.
- Crypt_Random
- Crypt_Rijndael
  - Crypt_Rijndael
    Pure-PHP implementation of Rijndael.
- Crypt_TerraDES
  - Crypt_TripleDES
    Pure-PHP implementation of Triple DES.
- Crypt_TripleDES
- Help
- LDAP
  - Ldap
    Ldap manages connection to LDAP and includes several helper functions.
- Math_BigInteger
  - Math_BigInteger
    Pure-PHP arbitrary precision integer arithmetic library. Supports base-2, base-10, base-16, and base-256 numbers.
- Net_SFTP
  - Net_SFTP
    Pure-PHP implementations of SFTP.
- Net_SSH1
  - Net_SSH1
    Pure-PHP implementation of SSHv1.
- Net_SSH2
  - Net_SSH2
    Pure-PHP implementation of SSHv2.
- PDF
  - UFPDF
    Main UFPDF class for creating Unicode PDF documents
  - lamPDF
    Creates a LAM information page in PDF format.
  - xmlParser
    Simple XML parser.
- PHP_Compat
- configuration
  - LAMCfgMain
    This class manages config.cfg.
  - LAMConfig
    This class manages .conf files.
- horde.cipher
  - Horde_Cipher_blowfish
- lam
  - smbHash
    Calculates NT and LM hashes.
- lib
  - AttributeType
    Represents an LDAP AttributeType
  - MatchingRule
    Represents an LDAP MatchingRule
  - MatchingRuleUse
    Represents an LDAP schema matchingRuleUse entry
  - ObjectClass
    Represents an LDAP objectClass
  - ObjectClassAttribute
    A simple class for representing AttributeTypes used only by the ObjectClass class.
  - SchemaItem
    Generic parent class for all schema items. A schema item is an ObjectClass, an AttributeBype, a MatchingRule, or a Syntax.
  - Syntax
    Represents an LDAP Syntax
- lists
  - lamAsteriskExtList
    Generates the list view.
  - lamBooleanListOption
    Boolean option for list configuration.
  - lamDHCPList
    Generates the list view.
  - lamGroupList
    Generates the list view.
  - lamHostList
    Generates the list view.
  - lamList
    Generates the list view.
  - lamListOption
    Represents a list configuration option.
  - lamListTool
    Represents a tool which can be included in the account lists.
  - lamMailAliasList
    Generates the list view.
  - lamNetgroupList
    Generates the list view.
  - lamSelectListOption
    Boolean option for list configuration.
  - lamSmbDomainList
    Generates the list view.
  - lamUserList
    Generates the list view.
- main
- metaHTML
  - htmlAccountPageButton
    Prints a button for the account pages.
  - htmlButton
    Simple button.
  - htmlDiv
    Creates a simple DIV element.
  - htmlElement
    Represents a HTML element.
  - htmlEqualHeight
    Sets all given elements to the same height.
  - htmlEqualWidth
    Sets all given elements to the same width.
  - htmlFieldset
    Generates a fieldset.
  - htmlGroup
    Groups multiple htmlElements.
  - htmlHelpLink
    Renders a help link.
  - htmlHiddenInput
    Generates a hidden input field.
  - htmlHorizontalLine
    Prints a horizontal line.
  - htmlImage
    Prints the HTML code for an image.
  - htmlInputCheckbox
    Prints the HTML code for a checkbox.
  - htmlInputField
    A standard input field.
  - htmlInputFileUpload
    Prints the HTML code for a file upload field.
  - htmlInputTextarea
    Prints the HTML code for a textarea.
  - htmlJavaScript
    Creates a JavaScript element.
  - htmlLink
    Generates a link.
  - htmlOutputText
    Prints the text and escapes contained HTML code by default.
  - htmlRadio
    Represents a radio selection.
  - htmlSelect
    Represents a select box.
  - htmlSortableList
    Creates a list of elements that can be sorted by the user via drag'n'drop.
  - htmlSpacer
    Adds an empty space with given width and height.
  - htmlStatusMessage
    Prints a status message (e.g. error message).
  - htmlSubTitle
    Generates a subtitle line. This is used to group multiple fields.
  - htmlTable
    Structures elements using a table.
  - htmlTableExtendedInputCheckbox
    Checkbox with descriptive label and help link.
  - htmlTableExtendedInputField
    An extended input field that combines label, input field and help.
  - htmlTableExtendedInputFileUpload
    File upload with descriptive label and help link.
  - htmlTableExtendedInputTextarea
    Text area with label and help link.
  - htmlTableExtendedRadio
    Radio list with descriptive label and help link.
  - htmlTableExtendedSelect
    Select with label and help link.
  - htmlTableRow
    A row inside a htmlTable.
  - htmlTitle
    Generates a title line. This is used for page titles.
- modules
  - account
    Manages the object class "account" for users and hosts.
  - accountContainer
    This class includes all modules and attributes of an account.
  - asteriskAccount
    Manages the Asterisk extension of user accounts.
  - asteriskExtension
    Manages Asterisk extensions.
  - asteriskVoicemail
    Manages the Asterisk extension of user accounts.
  - authorizedServiceObject
    Provides Authorized Service for accounts.
  - baseModule
    Parent class of all account modules.
  - ddns
    Manages DDNS entries.
  - dhcp_settings
    Manages DHCP entries.
  - eduPerson
    Manages the eduPerson extension for user accounts.
  - fixed_ip
    Manages DHCP host entries.
  - freeRadius
    Manages FreeRadius accounts.
  - generalInformation
    Shows general information like the creation time of an account.
  - hostObject
    Manages the hosts to which a user may login.
  - ieee802device
    Provides MAC addresses for hosts.
  - imapAccess
    Manages mailboxes on an IMAP server.
  - inetLocalMailRecipient
    Provides mail routing for users.
  - inetOrgPerson
    This module manages LDAP attributes of the object class inetOrgPerson (e.g. name and address).
  - kolabGroup
    Manages Kolab group accounts.
  - kolabUser
    Manages Kolab user accounts.
  - ldapPublicKey
    Manages SSH public keys.
  - nisMailAlias
    Provides NIS mail alias management.
  - nisnetgroup
    Manages entries based on the object class nisNetgroup.
  - passwordService
    This interface needs to be implemented by all account modules which manage passwords.
  - posixAccount
    Manages the object class "posixAccount" for users and hosts.
  - posixGroup
    Manages the object class "posixGroup" for groups.
  - puppetClient
    Manages Puppet configuration options.
  - quota
    Manages quotas for users and groups.
  - range
    Manages DHCP ranges for DHCP server.
  - samba3domain
    Represents a Samba 3 domain entry
  - sambaDomain
    Manages Samba 3 domain entries.
  - sambaGroupMapping
    Manages the object class "sambaGroupMapping" for groups.
  - sambaMungedDial
    Manages terminal server settings for Samba 3.
  - sambaSamAccount
    Manages the object class "sambaSamAccount" for users and hosts.
  - shadowAccount
    Manages the object class "shadowAccount" for users.
  - smbHash
    Calculates NT and LM hashes.
  - systemQuotas
    Manages user quotas with the object class systemQuotas.
  - windowsGroup
    Manages Windows AD (e.g. Samba 4) groups.
  - windowsHost
    Manages Windows AD (e.g. Samba 4) hosts.
  - windowsPosixGroup
    Manages Unix groups in Windows LDAP schema.
  - windowsUser
    Manages Windows AD (e.g. Samba 4) users.
- phpLDAPadmin
- profiles
- selfService
  - selfServiceProfile
    Includes all settings of a self service profile.
- tools
  - LAMSubTool
    Represents a subtool.
  - LAMTool
    Represents a tool.
  - toolFileUpload
    File upload
  - toolOUEditor
    OU editor
  - toolPDFEditor
    PDF editor
  - toolProfileEditor
    Profile editor
  - toolSchemaBrowser
    Schema browser
  - toolServerInformation
    Server information
  - toolTests
    Tests page
- types
  - asteriskExt
    The account type for Asterisk extensions.
  - baseType
    This is the parent class of all account types.
  - dhcp
    The account type for DHCP
  - group
    The account type for group accounts (e.g. Unix and Samba).
  - host
    The account type for host accounts (e.g. Samba).
  - mailAlias
    The account type for mail aliases.
  - netgroup
    The account type for NIS netgroups.
  - smbDomain
    The account type for Samba domains.
  - user
    The account type for user accounts (e.g. Unix, Samba and Kolab).